      subroutine dc(n, d, e, z, ldz, INFO, RET)
      use OMP_LIB    
      implicit NONE

      integer, intent(in)           :: n, ldz
      real(8), intent(inout)        :: d(1:n), e(1:n)
      real(8), intent(out)          :: z(1:ldz,*)
      integer(8), intent(out)       :: info
      real(8), intent(out)          :: ret

      integer                       :: i,j,nx,istat,NB,lddz,lddw
      integer                       :: LGN
 
      integer                       :: world_size, my_rank, ierr
      integer(8)                    :: TRILWMIN, LWORK, LIWORK
 
      real(8), pointer              :: work(:)
      integer, pointer              :: iwork(:)

      integer(8), external          :: dc_buffersize
      integer(8)                    :: l_array
      integer(4)                    :: linfo
      integer                       :: DIM_SWITCH

      real(8)  :: d1,d2

      include 'trd.h'
      include 'DC_ADD.h'

      flops = 0D0
      dgemm_time = 0D0
      p_time0 = 0D0
      p_timer = 0D0
      p_time2 = 0D0
      p_time3 = 0D0
      p_times = 0D0
      p_timez = 0D0
 
      DIM_SWITCH = 4000

#if TIMER==1
      d1 = OMP_Get_wtime()
#endif

      l_array = 0
      if ( size_A == 0 ) then
         call cuda_sync( 1 )
         l_array = dc_buffersize( n, ldz )
         ierr = cuda_alloc_available( devPtr_A, l_array, size_A )
         size_A = size_A/8
         call cuda_sync( 1 )
         if ( ierr /= 0 ) then
            print*,"Device Memory allocation fault [D&C]"
            stop
         endif
      endif

! preparing working arrays
      LGN = INT( LOG( DBLE( n ) ) / LOG( 2D0 ) )
      IF( 2**LGN < n ) LGN = LGN + 1
      IF( 2**LGN < n ) LGN = LGN + 1
      LWORK  = 1 + 3*INT(n,8) + 2*INT(n,8)*LGN + 3*INT(n,8)**2
      LIWORK = 6 + 6*INT(n,8) + 5*INT(n,8)*LGN
      allocate(work(lwork), iwork(liwork), stat=istat)
      if(istat.ne.0) then
         print*,"Memory exhausted [D&C]"
         call flush(6)
         STOP
      end if
#if TIMER==1
      d2 = OMP_Get_wtime()
      print*,"RERE0-2",d2-d1
#endif
!*
!*  Special call to initiate the internal constants in DLAED6
!*
!      call DLAED6_INIT()

      d1 = OMP_Get_wtime()
      if ( size_A == 0 .OR. n < DIM_SWITCH ) then
      CALL DSTEDC( 'I', n, d, e, z, ldz, WORK, INT(LWORK,4), IWORK,
     $             INT(LIWORK,4), LINFO )
      INFO = LINFO
      else
      CALL DSTEDC_EIGENG( 'I', n, d, e, z, ldz, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
      endif
      d2 = OMP_Get_wtime()
      if(INFO/=0) then
         print*,"INFO=",INFO,INFO/(N+1)+1,MOD(INFO,N+1)+1
         stop
      end if

!      print*,"DSTEDC",d2-d1

! freeing working arrays
      deallocate(work)
      deallocate(iwork)

      if ( l_array > 0 ) then
         call cuda_sync( 1 )
         call cuda_free( devPtr_A )
      endif
      call cuda_sync( 1 )

!      print*," :: DIVIDE.",p_time0
!      print*," :: PDLAED2",p_time2
!      print*," :: PDLAED3",p_time3
!      print*,"      :: PDLAED4",p_timer
!      print*,"      :: Lowner ",p_timez
!      print*,"      :: PDGEMM", dgemm_time
!      print*," PDLASET",p_times

      ret = flops ! dgemm_time ! flops/dgemm_time

      return
      end subroutine
