       subroutine  tred1_aux(
     &                a, nm,
     &                u_x, v_x,
     &                i, i_base, m,
     &                d, e, beta)
       use OMP_LIB
       implicit NONE

       integer, intent(in)    :: nm, i, i_base, m
       real(8), intent(inout) :: a(1:nm,*)
       real(8), intent(inout) :: u_x(1:nm)
       real(8), intent(inout) :: v_x(1:nm)
       real(8), intent(inout) :: d(*), e(*), beta

       integer                :: L, j

       real(8) :: d1, d2
       real(8) :: anorm2, a_n, g_n

       integer                :: local_size, local_rank


       real(8)      t2_reduce1, t2_reduce2
       common /t2/  t2_reduce1, t2_reduce2

       integer(8) :: idx_A, idx_U, idx_V, idx_UX, idx_VX
       integer(8) :: mlen

       real(8), external :: dnrm2, ddot


       include 'trd.h'
       include 'CSTAB.h'
       include 'param.h'


       L = i - 1

       if ( omp_get_num_threads()==1 .or. omp_get_thread_num()==1 ) then

         anorm2 = dnrm2( L, u_x, 1 )
         a_n    =  u_x(L)
         g_n    = -SIGN(ONE, a_n)
         beta   =  anorm2 * ( anorm2 - a_n * g_n )
         g_n    =  anorm2 * g_n

         a_n    =  a_n - g_n
         u_x(L) =  a_n

         e (i)  =  g_n
         d (i)  =  u_x(i)

         u_x(i:i_base+m) = ZERO

       end if

!$OMP BARRIER

!$OMP MASTER

       idx_A = 0
       idx_U = int(i-i_base-1,8)*int(nm*8,8)
       idx_V = int(i-i_base-1,8)*int(nm*8,8)

       if ( beta /= ZERO ) then

          mlen = int(i_base + m, 8)
          call cuda_sync( -1 )
          call cuda_set_vector( mlen, eSize, u_x, devPtr_UX+idx_U )
          call cuda_sync( 1 )

          call ASPEN_DSYMV('U', L,
     &         1D0,
     &              devPtr_A+idx_A, nm,
     &              devPtr_UX+idx_U, 1,
     &         0D0, devPtr_VX+idx_V, 1)


       if ( .TRUE. .OR. i_base+m-i < 32 .OR. L < 8000 ) then

       else

       idx_UX = int(i-i_base,8)*int(nm*8,8)
       idx_VX = int(i-i_base,8)*int(nm*8,8)

          call CUBLAS_DGEMV('T', L, i_base+m-i,
     &                      ONE,  devPtr_VX+idx_VX, nm,
     &                            devPtr_UX+idx_U,  1,
     &                      ZERO, devPtr_UY, 1)
          call CUBLAS_DGEMV('N', L, i_base+m-i,
     &                     -ONE,  devPtr_UX+idx_UX, nm,
     &                            devPtr_UY,  1,
     &                      ONE,  devPtr_VX+idx_V, 1)
          call CUBLAS_DGEMV('T', L, i_base+m-i,
     &                      ONE,  devPtr_UX+idx_UX, nm,
     &                            devPtr_UX+idx_U,  1,
     &                      ZERO, devPtr_UY, 1)
          call CUBLAS_DGEMV('N', L, i_base+m-i,
     &                     -ONE,  devPtr_VX+idx_VX, nm,
     &                            devPtr_UY,  1,
     &                      ONE,  devPtr_VX+idx_V, 1)

       end if

          mlen = int(L, 8)
          call cuda_sync( -1 )
          call cuda_get_vector( mlen, eSize, devPtr_VX+idx_V, v_x )
          call cuda_sync( 1 )

       else

          call ASPEN_DZERO( devPtr_UX+idx_U, i_base+m )
          call ASPEN_DZERO( devPtr_VX+idx_V, i_base+m )

          u_x(1:i_base+m) = ZERO

       endif

!$OMP END MASTER


       return
       end subroutine

