       subroutine tred1_local_2update0(
     &               u_x, nm,
     &               ux, vx, beta_last,
     &               i_base, i)
       use OMP_LIB
       implicit NONE
!
       integer, intent(in)    ::  nm
       real(8), intent(inout) ::  u_x(1:nm)
       real(8), intent(in)    ::  ux(1:nm)
       real(8), intent(in)    ::  vx(1:nm)
       real(8), intent(in)    ::  beta_last
       integer, intent(in)    ::  i_base, i
!
       include 'trd.h'
       include 'param.h'
       include 'CSTAB.h'
!
       integer                ::  j, k, l
!
       real(8)                :: ux0, vx0
       real(8)                :: uy0, vy0
       real(8)                :: w0

!
! 0 or 1 pass
!

          if ( i - i_base <= 1 ) return
          if ( beta_last == ZERO  ) return
!
! 0 or 1 pass
!
!
          L = i - 1
!=
          uy0 = ux(L+0)
          vy0 = vx(L+0)

!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do j=1,L-1
             ux0 = ux(j)
             vx0 = vx(j)
             w0 = u_x(j)
     &              -(ux0*vy0)
     &              -(vx0*uy0)
             u_x(j) = w0
          end do

          u_x(L) = u_x(L) - 2*uy0*vy0

!
! 0 or 1 pass
!

       return
       end subroutine ! tred1_local_2update

