      subroutine  tred1_init(a, nm, n, d_out)
!$    use omp_lib
      implicit NONE

      integer, intent(in)    ::  nm, n
      real(8), intent(inout) ::  a(1:nm, *)
      real(8), intent(out)   ::  d_out(*)

      integer                ::  i, j

      integer                ::  local_size, local_rank

      include 'trd.h'
      include 'trd_au.h'
      include 'CSTAB.h'
      include 'param.h'

      integer(8)             ::  mlen

      local_rank = omp_get_thread_num()
      local_size = omp_get_num_threads()
!
! all threads pass
!
      if ( local_rank == 0 ) then

         mlen = int(nm,8)*int(n-1,8)+int(n,8)
         call cuda_sync( -1 )
         call cuda_set_vector( mlen, eSize, a, devPtr_A )
         call cuda_sync( 1 )

      end if
!
! all threads pass
!
      return
      end subroutine  tred1_init


      subroutine  tred1_final(a, nm, n, d_out, e_out, m)

      use OMP_LIB
      implicit NONE

      integer, intent(in)    ::  nm, n, m
      real(8), intent(inout) ::  a(1:nm, *)
      real(8), intent(out)   ::  d_out(*)
      real(8), intent(out)   ::  e_out(*)

      integer                ::  i, j
      integer(8)             ::  mlen

      include 'trd.h'
      include 'trd_au.h'
      include 'CSTAB.h'


      if ( m == 1 ) then
         mlen = int(nm+2,8)
         call cuda_sync( -1 )
         call cuda_get_vector( mlen, eSize, devPtr_A, a )
         call cuda_sync( 1 )
      end if

      if ( n >= 2 ) then
         d_out(1) =   a(1, 1)
         d_out(2) =   a(2, 2)
         e_out(2) =  -a(1, 2)
         a(1, 2)  = 2*a(1, 2)
      end if


      return
      end subroutine tred1_final

